#######################################
##     Random generation from the    ##
## Bivariate Polynomial Gaussian CWM ##
#######################################

source("ML.R")

rPolyCWM <- function(n,prior,muX,sdX,beta,sdY){
  
  k <- length(prior)
  r <- ncol(beta)
  
  library(multinomRob)
  nj <- rowSums(rmultinom(1, n=n, prob=prior))
  pj <- nj/n
  x  <- NULL
  for(j in 1:k){
    
    x[[j]] <- rnorm(nj[j],mean=muX[j],sd=sdX[j])
    if(j==1) X <- x[[j]]
    else     X <- c(X,x[[j]])
    
  } 
  
  print(X)
  
  y   <- NULL
  for(j in 1:k){
    
    muY     <- polyfun(x[[j]],beta[j,])
    y[[j]]  <- rnorm(nj[j],mean=muY,sd=sdY[j])
    if(j==1) Y <- y[[j]]
    else Y <- c(Y,y[[j]])
    
  }
  
  return(
    list(
      X     = X,
      Y     = Y,
      group = rep(1:k,nj)
      )
    )
  
}
